/*
 *   Portable Host Development Kit
 *   EXAMPLE PROGRAM #3
 *
 * This program is Micheal Keane's "Invasion!" program ported to use the
 * PDK. The documentation for Invasion! follows at the end of the file.
 *
 * This file is copyrighted by Micheal Keane in 1995.
 * You may copy and distribute this file freely as long as you retain
 * this notice and explicitly document any changes you make to this file
 * (along with your name and date) before distributing modified
 * versions.
 *
 * This is an example program for instructional purposes only. It is not
 * guaranteed to work correctly, or even to necessarily compile on all
 * systems. You use this program at your own risk.
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <phostpdk.h>

FILE * planfile;
FILE * logfile;
char path[256]= {'\0'};
int pathdir;

#ifndef min
#define min(a,b) ((a) < (b) ? (a) : (b))
#endif
int invoptions(void);
char * pathtofile(const char * fname);
int main(int args, char* cline[]);
int lprintf(int scrn, const char * mess, ...);


int main (int args, char* cline[]) {
  int pts[11] = {0};
  int newpts[11] = {0};
  int hws[11] = {0};
  int list[11] = {0};
  int x, y, z;
  int hwval, exval, listtype, argst;
  int * extra;  int * expts;
  char * messages[21];
  char * message;
  char filename[256] = {'\0'};
  char fill;
  Int16 dummy1, dummy2;

  printf("Invasion! v1.2b by Micheal Keane\n");
  printf(" An invasion scenario util for hosts\n");

    InitPHOSTLib();

  printf("%d %s %s\n", args, (args > 1 ? cline[0] : ""),
                             (args > 2 ? cline[1] : ""));

#ifdef THINK_C  /* For Macintosh */
  strcpy(path, "");
#else
  strcpy(path, "./");
#endif
  pathdir = 0; hwval = 1; exval = 0; listtype = 1;
  argst = 1;

  if (args > 1) {
    if (cline[1][0] != '/') {
      strcpy(path, cline[1]);
      argst++;
    }
    for (x = argst; x < args; x++) {
      if (cline[x][0] == '/') {
        if ((x + 1) < args) {
          switch(cline[x][1]) {
            case 'h':
              hwval = atoi(cline[x + 1]);
              x++;
              break;
            case 'l':
              listtype = atoi(cline[x + 1]);
              x++;  
              break;
          }
        }
      }
    }
    if ((hwval < 0)) {
      invoptions();
      exit(1);
    }
    if ((listtype < 1) || (listtype > 3)) {
      lprintf(1, "illegal listtype, defaulting to 1\n");
      listtype = 1;
    }
  }

  x = strlen(path) - 1;

  gGameDirectory = path;

  if (path[x] != '/') {
#ifdef THINK_C
    strcat(path, ":");
#else
    strcat(path, "/");
#endif
  }

  strcpy(filename, pathtofile("inv.log"));
  logfile = fopen(filename, "w+t");
  if (logfile == NULL)  {
    printf("Invalid path!\n");
    exit(1);
  }
  fclose(logfile);

  lprintf(0, "Invasion! v1.2b by Micheal Keane\n");
  lprintf(0, " An invasion scenario util for hosts\n");
  lprintf(0, "%d %s %s\n", args, (args > 1 ? cline[0] : ""),
                                 (args > 2 ? cline[1] : ""));
  lprintf(1, "hwval=%d\n", hwval);
  lprintf(1, "listtype=%d\n", listtype);
  lprintf(1, "path=%s\n", path);
  
  if ((message = (char *)malloc(1600)) == NULL) {
    lprintf(1, "(message = (char *)malloc(1600)) failed\n");
    exit(1);
  }
  message[0] = '\0';

  for (x = 0; x < 21; x++) {
    if ((messages[x] = (char *)malloc(40)) == NULL) {
      lprintf(1, "(messages[%i] = (char *)malloc(40)) failed\n", x);
      exit(1);
    }
    strcpy(messages[x], "\0");
  }  

  loadfiles();

  strcpy(filename, pathtofile("inv1.hst"));
  lprintf(1, "Now opening and reading %s...\n", filename);
  planfile = fopen(filename, "r+t");
  if (planfile != 0) {
    for (x  = 0; x < 11; x++) {
      fscanf(planfile, "%d %d", &hws[x], &pts[x]);
    }
    fclose(planfile);
  } else {
    fclose(planfile);
    strcpy(filename, pathtofile("refdata.hst"));
    lprintf(1, "inv1.hst not found... scanning %s\n", filename);
    planfile = fopen(filename, "r+b");
    if (planfile != 0) {
       fread(hws, 2, 3, planfile);
       fread(hws, 2, 11, planfile);
    } else {
       strcpy(filename, pathtofile("bdata.hst"));
       lprintf(1, "refdata.hst not found... scanning %s\n", filename);
       if (! Read_Bases_File(&dummy1, &dummy2)) {
         lprintf(1, "Can't read bdata.hst!\nExiting Invasion!\n");
         invoptions();
         exit(1);
       }
       for (x = 1; x <= PLANET_NR; x++) {
         if (IsBaseExist(x)) hws[BaseOwner(x)-1] = x;
       }
    }
  }
  fclose(planfile);

  strcpy(filename, pathtofile("inv2.hst"));
  lprintf(1, "Looking for %s...\n", filename);
  planfile = fopen(filename, "r+t");
  if (planfile != NULL) {
    fscanf(planfile, "%d", &exval);
    if ( ((extra = (int *)malloc(2 * (exval + 1))) == NULL) ||
         ((expts = (int *)malloc(2 * (exval + 1))) == NULL) ) {
       lprintf(1, "((extra = (int *)malloc(%i)) || (expts = (int *)malloc(%i))) failed!\n",
            (2 * (exval + 1)), (2 * (exval + 1)));
       exit(1);
    }
    for (x = 0; x < exval; x++) {
      fscanf(planfile, "%d %d", (extra + x), (expts + x));
    }
  }
  else {
    lprintf(1, "optional inv2.hst not found...\n");
  }
  fclose(planfile);

  strcpy(filename, pathtofile("pdata.hst"));
  lprintf(1, "Now opening and reading %s\n", filename);
  if (! Read_Planets_File(&dummy1)) {
    lprintf(1, "Can't read pdata.hst!\nExiting Invasion!\n");
    invoptions();
    exit(1);
  }
  lprintf(1, "tallying points this turn...\nstarting with homeworlds...\n");
  for (x = 0; x < 11; x++) {
    if ((hws[x] != 0) && (hws[x] < 501)) {
      if (   (PlanetOwner(hws[x]) != NoOwner)
          && (PlanetOwner(hws[x]) <= RACE_NR)
          && (PlanetOwner(hws[x]) != x+1)
         ) {
          newpts[PlanetOwner(hws[x])-1] += hwval;
      }
    }
  }

  if (exval > 0) {
    lprintf(1, "tallying extra points...\n");
    for (x = 0; x < exval; x++) {
      if (   (PlanetOwner(extra[x]) != NoOwner)
          && (PlanetOwner(extra[x]) <= RACE_NR)
         ) {
        newpts[PlanetOwner(extra[x])-1] += expts[x];
      }
    }
  }
    
  fclose(planfile);

  for (x = 0; x < 11; x++) {
    pts[x] += newpts[x];
  }
  strcpy(filename, pathtofile("inv1.hst"));
  lprintf(1, "Now opening and writing %s\n", filename);
  planfile = fopen(filename, "w+t");
  for (x  = 0; x < 11; x++) {
    fprintf(planfile, "%i %i\n", hws[x], pts[x]);
  }
  fclose(planfile);

  lprintf(1, "preparing message to players..\n");
  sprintf(messages[0], "   <<< Invasion Report! >>>\r");
  sprintf(messages[1], "\r");
  sprintf(messages[2], " # Name                 Total  New\r");
  for (x = 0; x < 11; x++) {
    sprintf(messages[x+3], "%2d %20s  %3d  %3d\r",
     x+1, RaceShortName(x+1, 0), pts[x], newpts[x]);
  }
  for (x = 14; x < 18; x++) {
    sprintf(messages[x], "\r");
  }
  sprintf(messages[18], "Invasion! v1.2b by Micheal Keane\r");
  sprintf(messages[19], "\r");

  lprintf(1, "ordering scores...\n");

  switch(listtype) {
    case 1:
      for (x = 0; x < 11; x++) {
        list[x] = pts[x];
      }
      break;
    case 2:
      for (x = 0; x < 11; x++) {
        list[x] = newpts[x];
      }
      break;
    case 3:
      for (x = 0; x < 11; x++) {
        list[x] = 12 - x;
      }
      break;
  }


  for (x = 0; x < 11; x++) {
    for (y = x; y < 11; y++) {
      if (list[y] > list[x]) {
        strcpy(messages[20], messages[x+3]);
        strcpy(messages[x+3], messages[y+3]);
        strcpy(messages[y+3], messages[20]);
        z = list[x]; list[x] = list[y]; list[y] = z;
      }
    }
  }

  strcpy(filename, pathtofile("invscore.txt"));
  planfile = fopen(filename, "w+t");
  for (x = 0; x < 20; x++) {
    printf("%s\n", messages[x]);
    fprintf(planfile, "%s\n", messages[x]);
  }
  fclose(planfile);

  lprintf(1, "shifting message...\n");
  
  for (x = 0; x < 20; x++) {
    strcat(message, messages[x]);
  }

  {
    char *messageArgv[1];
    messageArgv[0] = message;

    for (x = 1; x < 12; x++) {
      if (hws[x - 1] != 0) {
        lprintf(1, "sending message to player %i\n", x);
        WriteMessageToRST(x, 1, messageArgv);
      }
    }
  }

  if (exval != 0) {
    free(extra);
    free(expts);
  }
  free(message);

  lprintf(1, "Finished!\n");
  return 0;
}

int invoptions() {
  printf("INV command line options\n");
  printf(" INV [Path] [/H ##]\n");
  printf("[Path] must be a valid directory\n");
  printf("/H ## where ## is the point value for homeworlds. Defaults to 1\n\n");

  return 0;
}

int loadfiles() {
  char filename[80];

  lprintf(1, "now opening and loading race.nm...\n");

  strcpy(filename, pathtofile("RACE.NM"));
  if (! Read_Racenames_File()) {
      lprintf(1, "Cannot read %s!\n", filename);
      exit(1);
  }

  return 1;
}

char * pathtofile(const char * fname) {
  static char fn[256] = {'\0'};
  sprintf(fn, "%s%s", path, fname);
  return fn;
}

int lprintf (int scrn, const char * mess, ...) {
  int x;
  va_list ap;
  char filename[256];

  va_start(ap, mess);

  strcpy(filename, pathtofile("inv.log"));
  logfile = fopen(filename, "a+t");
  x = vfprintf(logfile, mess, ap);
  fclose(logfile);

  if (scrn != 0) {
    vprintf(mess, ap);
  }
  va_end(ap);
  return x;
}

/*      DOCUMENTATION FOR INVASION!

INV: The Invasion Scenario
v1.2b by Micheal Keane(micheal.keane@tpalley.eskimo.com)

 For those of us who think ref is just too limiting!

 Warranty:
  If you use & you lose, you pay & I don't.

 This is a relatively simple program for invasion scenarios. Basically, run
the program as follows:

INV [path] [options]

  valid options are:
    /h hwval  -- num is the number of points awarded for captured homeworlds.
                 defaults to 1.

    /l type   -- How you'd like the races ranked in the message.
                 valid values for type are:
                  1  -- rank by total points (default)
                  2  -- rank by new points this turn
                  3  -- list in order of race, 1 to 11

 Run it AFTER (p)host. Not during the AUXHOST phases.

 Files in INV12B.ZIP
  INV.EXE      -- main EXE
  INV.DOC      -- Docs you're reading right now
  INV.C        -- ANSI C source code
  ALTSPEC.H    -- VGAP file structure based largely on VPCPLAY.BAS's specs

 INV will create two files each run in the path directory:
  INVSCORE.TXT -- a copy of the message sent to players, suitable for
                  BBS bulletins and the like
  INV.LOG      -- a log file of the program's run

 files read & where they should be:
  RACE.NM     -- game or current dir (required)
  PDATA.HST   -- game dir (required)
  REFDATA.HST -- game dir (used for init if present)
  BDATA.HST   -- game dir (required for init if refdata.hst ain't there)

 Configuration:
  INV1.HST    -- main text datafile for homeworlds and total scores
  INV2.HST    -- optional text file for additional point planets

  The format of INV1.HST is:

   [homeworld] [score]

  for _ALL_ 11 lines. A sample INV1.HST:

250 5
220 24
279 26
189 117
102 125
474 34
459 90
224 67
4 13
460 21
262 103

  The format of INV2.HST is:
   The first line contains the number of ADDITIONAL point planets. Don't
   include the 11 homeworlds in this number.
   For the number of lines after that, the format goes:
   [planet] [points]

   points being the number of points awarded per turn when a race holds that
   planet.

   A short sample INV2.HST:

4
21 5
134 1
256 1
345 1

 The format MUST be followed exactly or you'll get weird numbers and really
 mess things up. There can be no comments on the lines either.

 Notes:
  In order to receive a status message, a player must have a homeworld
  number. What if you're not playing a "capture enemy homeworlds" scenario?
  Just set the homeworld value to 0. ie: INV [path] /h 0

Known bugs:
  If you're using the old version of MASTER or a similar program that doesn't
  generate a REFDATA.HST file that contains the homeworlds, INV will scan
  BDATA.HST for planets with starbases, since usually, the only starbase a
  player will have at the beginning of the game is their homeworld. For
  some reason though, some planets just get skipped. Usually one or two from
  my tests. I haven't absolutely NO idea why it's doing this. Totally eludes
  me. Thus, it'd be wise to know what the homeworld numbers are to fill in
  the spaces.

History:
  1.0  -- released for use in game 11 on Lame BBS only
        - writes to seperate textfile for hostmess to use
  1.1a -- thanks to Thomas Voigt, this version writes directly to the RST
        - no longer generates text file of message
        - lock up bugs fixed somehow
        - reworking of code to speed up some things which might give a
          smaller EXE size as well
        - I've finally learned how to use strings in C! =-)
  1.1b -- at Gordy's request, INV generates the text file again
  1.1c -- INV wasn't sending messages to player 11 as well as other
          message sending problems
        - not as much stuff written to the log anymore
        - more error checking for malloc() failures added
  1.1d -- INV.CPP renamed INV.C to show ANSI compatibility
        - altspec.h included and is ANSI compatible now
        - released to the general public
       -- vicious bug discovered and quashed, didn't rename version
          but one copy did make it to an ftp site. hopefully killed.
  1.2a -- race.nm required in either the current or game directory
        - the format of the scoring message changed
          here's a short sample:
             # Name                 Total  New
            11 The Colonies           99    0
             8 The Evil Empire        57    0
             6 The Cyborg             56    0

          notice the inclusion of short racenames and the fact that the
          scores are listed in descending order
  1.2b -- new command line option of /l to make the listing method
          configurable
        - cleaned up the docs quite a bit
        - new code for the command line processing, should be a bit more
          flexible now. ie: bad commands are ignored


Thanks to:
  Tim Wisseman for writing VGA Planets, of course.
  Thomas Voigt et al for the "insert message into RST" routines
  Gordy Pine of Lame BBS for making me write this utility
  My parents for paying the phone bill

Portability? :
  The program is 100% ANSI C so theoretically, it should be portable to just
  about anything. HOWEVER, if the byte ordering is different on the platform,
  this program will fuck the RST up royally. The code in the RST routines
  for reordering the bytes might prevent this. I'm really not sure.

  Please Email me about this if you want to port it to another platform.
  Tell me if you're sucessful in your venture and where a copy of the
  ported version can be obtained.

other projects:
SHIPLIST v1.1 -- short program for players and hosts alike. dumps shipspecs
 into a human readable text file. simple to use! 100% ANSI C
CAPFLAG -- Capture the flag! The object is to tow the flag to your homeworld
 for 5 turns. But, the catch is that everyone else knows who has it and
 where they are. Great fun if everyone actually plays. Should be released
 very soon. written in QuickBasic, thinking of an ANSI C version.
 "When I Have The Time"(tm)
BEAMS -- my shiplist editor, probably won't be released although it IS a
 pretty decent first C++ effort.

Project X -- may never be released for certain reasons... but you'll
 know what is it if/when it's released to the general public. in private
 testing and is ANSI C. Don't ask. =-)

*/
